note
	description: "once_query application root class"
	date: "$Date$"
	revision: "$Revision$"

class
	TEST_A

inherit
	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- Run application.
		do
			add_boolean_case (agent test_array)
			add_boolean_case (agent test_once_array)

			show_browser
			run_espec
		end

feature
	test_array: BOOLEAN
		local
			a: A
			arr1, arr2: ARRAY[STRING]
		do
			create a.make

			arr1 := a.new_array ("Alan")
			Result := arr1.count = 1 and arr1[1] ~ "Alan"
			check Result end

			arr2 := a.new_array ("Mark")
			Result := arr2.count = 1 and arr2[1] ~ "Mark"
			check Result end

			Result := not (arr1 = arr2)
			check Result end
		end

	test_once_array: BOOLEAN
		local
			a: A
			arr1, arr2, arr3: ARRAY[STRING]
		do
			create a.make

			arr1 := a.new_once_array ("Alan")
			Result := arr1.count = 1 and arr1[1] ~ "Alan"
			check Result end

			arr2 := a.new_once_array ("Mark")
			Result := arr2.count = 1 and arr2[1] ~ "Alan"
			check Result end

			arr3 := a.new_once_array ("Tom")
			Result := arr3.count = 1 and arr3[1] ~ "Alan"
			check Result end

			Result := arr1 = arr2 and arr2 = arr3
			check Result end
		end

end
